/////////////这里写你的API///////////////////////
/**
//api function模板
-------------
//注册(用于频繁execute时，设置opts)
$.pa.inject(apiname,opts);
//执行
$.pa.execute(apiname,otherOpts);
//最简执行POST
$.pa.execute("",{url:"url"});
----------------
//opts\otherOpts模板
var opts = {};
opts.url = "action";
opts.input = {FLAG:"OPERATOR_LOGIN",TEL:"20000000001",IMSI:123456,PASSWD:"HELLO"};
---非必填
opts.success = function(data){...}
opts.error = function(data){...}
---以下同jquery.ajax.options
opts.contentType = "application/x-www-form-urlencoded";//default
opts.type = "post";//default
opts.dataType = "none";//default
...
**/
//跨域访问的代理地址。
;(function($){
  var APIPROXY;
  function setApiProxy(ap){
    APIPROXY = ap;
  }
  var _apis = [];
  function postApi(){
    return {"apis":_apis,"inject":inject,"execute":execute,"setApiProxy":setApiProxy};
  }
  var pa;
  $.pa = pa = postApi();
  function getFuncName(func){
    var funcName = String(func) ;
    return funcName.replace(/^function(\s|\n)+(.+)\((.|\n)+$/,'$2');
  }
  var _optMap = {};
  function inject(api,opts){
    if(_apis.indexOf(api)>=0)
    {
      throw new Error("该POST API已被注册!"+api);
      return;
    }
    _optMap[api] = opts;
    _apis.push(api);
  }
  function execute(apiname,replaceOpt){
    var opt = _optMap[apiname] || {};
    opt = $.extend(true, {}, opt);//$(opt).clone();
    if(replaceOpt){
      for(var t in replaceOpt)
        opt[t] = replaceOpt[t];
    }
	if(typeof(api) != "undefined" && opt.input)
		opt.input.deviceid = api.deviceId;
    //超时5s
    var ajaxOpt = {type:"post",timeout:5000,url:opt.url,data:JSON.stringify(opt.input)};
    for(var t in opt)
    {
      if(["success","error","data"].indexOf(t)<0)
        ajaxOpt[t] = opt[t];
    }
    if($.isFunction(opt.success))
    {
      ajaxOpt.success = function(data){
        if(!data) data = {error:"RETURN NULL OR BLANK."};
        if($.isPlainObject(data) || $.isArray(data))
        {
        }
        else
        {
          try{
            data = JSON.parse(data);
          }catch(e){
            data = {error:"JSON PARSE ERROR:"+data};
          }
        }
        if(data.error && $.isFunction(opt.error))
          opt.error(data);
        else
          opt.success(data);
      }
    }
    if($.isFunction(opt.error))
    {
      ajaxOpt.error = function(jx,state,ethr){
        var data = {error:state};
         opt.error(data);
      }
    }
    //使用系统ajax（可跨域访问）
    if(APIPROXY){
      ajaxOpt.url = APIPROXY + ajaxOpt.url;
      if( typeof api == "undefined")
      {
        console.log("SYS AJAX NOT READY!!!");
        return;
      }
      else{
        var okf = ajaxOpt.success;
        var errf = ajaxOpt.error;

        api.ajax({
            method : "post",
            data: {body:ajaxOpt.data},
            url: ajaxOpt.url,
            timeout:ajaxOpt.timeout
          },function(ret,error){
          console.log("RET:",ret,"ERR:",error);
          if(ret){
            if($.isFunction(okf)) okf(ret);
          }
          else{
            if($.isFunction(errf)) okf(errf);
          }
        });
      }
    }
    else{
      $.ajax(ajaxOpt);
    }
  }
}(window.Zepto||window.jQuery||window.$))